Procedure MaskPic(X,Y,Width,Height:integer; Maskcolor:byte; Sprite,
Dest:Pointer);
 Begin

  If (x <= -width) or (x >= 320) or (y <= -height) or (y >= 200) then exit;
 Asm
   PUSH  DS             { save DS. Turbo Pascal automatically }
                        { saves other registers (ES SI DI)    }
   LDS   SI,Sprite      { Make DS:SI point to image data }
   MOV   AX,WIDTH       { store width in variable }
   MOV   DX,AX
   PUSH  DX             { Save width for use with the }
                        { actual screen copying }
   ADD   AX,X           { Add X to width, check for right side cut }
   PUSH  Width          { save origonal width for possible top cutting }
   CMP   AX,320         { Check for right side clipping }
   JG    @RightCut
   SUB   AX,X           { Check for left side clipping }
   JC    @LeftCut
   JMP   @CheckBottom   { no clipping necessary on sides }

 @RightCut:
   SUB   AX,Width
   SUB   AX,320
   NEG   AX             { AX= -(new width), NEG to get + value }
   MOV   Width,AX       { set new width according to rightclip }
   JMP   @CheckBottom

 @LeftCut:
   ADD   AX,X
   MOV   Width,AX       { set width according to left clip }
   SUB   DX,AX
   ADD   SI,DX
   XOR   BX,BX
   MOV   X,BX           { recalculate X parameter }

 @CheckBottom:
   MOV   AX,Height
   ADD   AX,Y
   CMP   AX,200         { Check for bottom cut }
   JG    @BottomCut

   SUB   AX,Y           { Check for top cut }
   JC    @TopCut
   POP   BX             { Saved Width is no longer necessary }
                        { so remove it from the stack }
   JMP   @Display       { no clipping on bottom necessary }

 @BottomCut:
   POP   BX             { remove saved width from stack }
                        { no longer necessary }
   SUB   AX,Height
   SUB   AX,200
   NEG   AX
   MOV   Height,AX       { adjust height according to clip}
   JMP   @Display

 @TopCut:
  ADD   AX,Y
  POP   BX             { retreive saved width value }
  PUSH  AX             { save AX, which is new height value }
  MOV   AX,Y
  NEG   AX
  IMUL  BX
  ADD   SI,AX          { adjust starting offset in sprite data }
                       { according to the top cut }
  POP   AX             { retrieve new height value }

  MOV   Height,AX       { adjust height according to clip}
  MOV   BX,0
  MOV   Y,BX            { Recalculate Y parameter }

 @Display:
 {  les   AX,dest}
 {  MOV   di,AX}
   LES di,dest
 {  XOR   DI,DI           { Make ES:DI point to A000h:0000h}
   MOV   AX,320
   IMUL  [Y]
   MOV   DI,AX
   ADD   DI,X            { Calculate screen offset }
   POP   DX              { Retrieve origional width }

   MOV   BX,Width        { Store values in registers }
   MOV   CX,Height       { for optimal speed }

   { The actual sprite is copied here.
     The Byte Ptr operations are used because they are faster
     than LODSB and STOSB on 386+ CPUs! Change it and see
     for yourself! The same is true with the DEC CX/JNZ
     instead of the LOOP instruction }

  @HeightLoop:               { Loop for height }
   PUSH  SI
   PUSH  DI

   PUSH  CX
   MOV   CX,BX
  @WidthLoop:                { Loop for width }
   MOV   AL,Byte Ptr [DS:SI] { get 1 byte of sprite data }
   CMP   AL,Maskcolor        { check for "transparent" color }
   JZ    @Skipped
   MOV   Byte Ptr [ES:DI],AL { Store sprite data onto screen }

  @Skipped:
   INC   SI
   INC   DI

   DEC   CX
   JNZ  @WidthLoop

   POP   CX
   POP   DI
   POP   SI
   ADD   DI,320  { Increment video memory by 1 line }
   ADD   SI,DX   { Increment Sprite data by 1 line (DX=Width)}

   DEC   CX
   JNZ  @HeightLoop

   POP   DS
   {all done, whew!}
 End
End;
